﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO.Ports;
using System.Threading;

namespace ArduinoSerialCommTest
{
    public partial class Form1 : Form
    {
        SerialPort arduinoComPort = new SerialPort("COM6", 28800, Parity.None, 8, StopBits.One);
        public Form1()
        {
            InitializeComponent();
            arduinoComPort.Open();
            arduinoComPort.DtrEnable = true;
            arduinoComPort.RtsEnable = true;
            arduinoComPort.DataReceived += new SerialDataReceivedEventHandler(OnReceivedData);

        }
        public static byte[] StrToByteArray(string str)
        {
            System.Text.ASCIIEncoding encoding = new System.Text.ASCIIEncoding();
            return encoding.GetBytes(str);
        }

        private void OnReceivedData(object sender, SerialDataReceivedEventArgs c){
            
           this.BeginInvoke(new EventHandler(DoUpdate));
        }

        private void DoUpdate(object sender, EventArgs e)
        {
            this.txtDataReceived.Text = this.txtDataReceived.Text + "Data Received: ";

            this.txtDataReceived.Text = this.txtDataReceived.Text + arduinoComPort.ReadExisting().ToString();
            this.txtDataReceived.Text = this.txtDataReceived.Text + Environment.NewLine;
            this.txtDataReceived.SelectionStart = this.txtDataReceived.Text.Length;
            this.txtDataReceived.ScrollToCaret();

        }
    

        private void button1_Click(object sender, EventArgs e)
        {
            
            
            string serialMessage = "LEDON#";
            try
            {

          
                arduinoComPort.Write(StrToByteArray(serialMessage), 0, serialMessage.Length);
               /* arduinoComPort.Write("L");
                Thread.Sleep(100);
                arduinoComPort.Write("E");
                Thread.Sleep(100);
                arduinoComPort.Write("D");
                Thread.Sleep(100);
                arduinoComPort.Write("O");
                Thread.Sleep(100);
                arduinoComPort.Write("N");
                Thread.Sleep(100);
                arduinoComPort.Write("#");
                Thread.Sleep(100);

                */
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }

        private void btnLEDOff_Click(object sender, EventArgs e)
        {
            string serialMessage = "LEDOFF";
            try
            {


                arduinoComPort.Write(StrToByteArray(serialMessage), 0, serialMessage.Length);
                /* arduinoComPort.Write("L");
                 Thread.Sleep(100);
                 arduinoComPort.Write("E");
                 Thread.Sleep(100);
                 arduinoComPort.Write("D");
                 Thread.Sleep(100);
                 arduinoComPort.Write("O");
                 Thread.Sleep(100);
                 arduinoComPort.Write("N");
                 Thread.Sleep(100);
                 arduinoComPort.Write("#");
                 Thread.Sleep(100);

                 */
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }
    }
}
